/*! \file DatasetInput.h 
 *  \brief: header file for datasetinput object
 */


#ifndef _DATASETINPUT_H_
#define _DATASETINPUT_H_

/*Headers:*/
/*{{{*/
#include "./Input.h"
#include "../../include/include.h"
class GaussTria;
/*}}}*/

class DatasetInput: public Input{

	public:
		int    enum_type;

		Inputs*     inputs;

		/*DatasetInput constructors, destructors: {{{*/
		DatasetInput();
		DatasetInput(int enum_type);
		~DatasetInput();
		/*}}}*/
		/*Object virtual functions definitions:{{{ */
		void  Echo();
		void  DeepEcho();
		int   Id();
		int   MyRank();
		int   ObjectEnum();
		Object* copy();
		/*}}}*/
		/*DatasetInput management: {{{*/
		int    InstanceEnum();
		Input* SpawnTriaInput(int* indices);
		Input* PointwiseDivide(Input* inputB){_error2_("not implemented yet");};
		Input* PointwiseMin(Input* inputB){_error2_("not implemented yet");};
		Input* PointwiseMax(Input* inputB){_error2_("not implemented yet");};
		ElementResult* SpawnResult(int step, IssmPDouble time){_error2_("not implemented yet");};
		void AddTimeValues(IssmPDouble* values,int step,IssmPDouble time){_error2_("not supported yet");};
		void Configure(Parameters* parameters);
		/*}}}*/
		/*numeriics: {{{*/
		void GetInputValue(bool* pvalue){_error2_("not implemented yet");};
		void GetInputValue(int* pvalue){_error2_("not implemented yet");};
		void GetInputValue(IssmPDouble* pvalue){_error2_("not implemented yet");};
		void GetInputValue(IssmPDouble* pvalue,GaussTria* gauss){_error2_("not implemented yet");};
		void GetInputValue(IssmPDouble* pvalue,GaussTria* gauss,IssmPDouble time){_error2_("not implemented yet");};
		void GetInputValue(IssmPDouble* pvalue,GaussPenta* gauss){_error2_("not implemented yet");};
		void GetInputValue(IssmPDouble* pvalue,GaussTria* gauss ,int index);
		void GetInputValue(IssmPDouble* pvalue,GaussPenta* gauss ,int index){_error2_("not implemented yet");};
		void GetInputDerivativeValue(IssmPDouble* derivativevalues, IssmPDouble* xyz_list, GaussTria* gauss){_error2_("not implemented yet");};
		void GetInputDerivativeValue(IssmPDouble* derivativevalues, IssmPDouble* xyz_list, GaussPenta* gauss){_error2_("not implemented yet");};
		void GetInputAverage(IssmPDouble* pvalue){_error2_("not implemented yet");};
		void GetVxStrainRate2d(IssmPDouble* epsilonvx,IssmPDouble* xyz_list, GaussTria* gauss){_error2_("not implemented yet");};
		void GetVyStrainRate2d(IssmPDouble* epsilonvy,IssmPDouble* xyz_list, GaussTria* gauss){_error2_("not implemented yet");};
		void GetVxStrainRate3d(IssmPDouble* epsilonvx,IssmPDouble* xyz_list, GaussPenta* gauss){_error2_("not implemented yet");};
		void GetVyStrainRate3d(IssmPDouble* epsilonvy,IssmPDouble* xyz_list, GaussPenta* gauss){_error2_("not implemented yet");};
		void GetVzStrainRate3d(IssmPDouble* epsilonvz,IssmPDouble* xyz_list, GaussPenta* gauss){_error2_("not implemented yet");};
		void GetVxStrainRate3dPattyn(IssmPDouble* epsilonvx,IssmPDouble* xyz_list, GaussPenta* gauss){_error2_("not implemented yet");};
		void GetVyStrainRate3dPattyn(IssmPDouble* epsilonvy,IssmPDouble* xyz_list, GaussPenta* gauss){_error2_("not implemented yet");};
		void ChangeEnum(int newenumtype){_error2_("not implemented yet");};
		void SquareMin(IssmPDouble* psquaremin, bool process_units,Parameters* parameters){_error2_("not implemented yet");};
		void ConstrainMin(IssmPDouble minimum){_error2_("not implemented yet");};
		void Scale(IssmPDouble scale_factor){_error2_("not implemented yet");};
		void ArtificialNoise(IssmPDouble min,IssmPDouble max){_error2_("not implemented yet");};
		void AXPY(Input* xinput,IssmPDouble scalar){_error2_("not implemented yet");};
		void Constrain(void){_error2_("not implemented yet");};
		void Constrain(IssmPDouble min,IssmPDouble max){_error2_("not implemented yet");};
		IssmPDouble InfinityNorm(void){_error2_("not implemented yet");};
		IssmPDouble Max(void){_error2_("not implemented yet");};
		IssmPDouble MaxAbs(void){_error2_("not implemented yet");};
		IssmPDouble Min(void){_error2_("not implemented yet");};
		IssmPDouble MinAbs(void){_error2_("not implemented yet");};
		void Extrude(void){_error2_("not implemented yet");};
		void VerticallyIntegrate(Input* thickness_input){_error2_("not implemented yet");};
		void GetVectorFromInputs(Vector* vector,int* doflist){_error2_("not implemented yet");};
		void GetValuesPtr(IssmPDouble** pvalues,int* pnum_values){_error2_("not implemented yet");};
		ElementResult* SpawnGradient(int step, IssmPDouble time){_error2_("not implemented yet");};
		void GetGradient(Vector* gradient_vec,int* doflist){_error2_("not implemented yet");};
		void ScaleGradient(IssmPDouble scale){_error2_("not implemented yet");};
		void SetGradient(Input* gradient_in){_error2_("not implemented yet");};
		void UpdateValue(IssmPDouble scalar){_error2_("not implemented yet");};
		void SaveValue(void){_error2_("not implemented yet");};
		/*}}}*/

};
#endif  /* _DATASETINPUT_H */
